package cn.iocoder.yudao.module.llm.service.modelassesstaskauto;

import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskauto.vo.ModelAssessTaskStoplistPageReqVO;
import cn.iocoder.yudao.module.llm.controller.admin.modelassesstaskauto.vo.ModelAssessTaskStoplistSaveReqVO;
import cn.iocoder.yudao.module.llm.dal.dataobject.modelassesstaskauto.ModelAssessTaskStoplistDO;
import cn.iocoder.yudao.module.llm.dal.mysql.modelassesstaskauto.ModelAssessTaskStoplistMapper;
import org.springframework.stereotype.Service;
import javax.annotation.Resource;
import org.springframework.validation.annotation.Validated;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

import cn.iocoder.yudao.framework.common.pojo.PageResult;
import cn.iocoder.yudao.framework.common.pojo.PageParam;
import cn.iocoder.yudao.framework.common.util.object.BeanUtils;



import static cn.iocoder.yudao.framework.common.exception.util.ServiceExceptionUtil.exception;
import static cn.iocoder.yudao.module.llm.enums.ErrorCodeConstants.*;

/**
 * 模型评估任务 —— 自动评估 ——停用词 Service 实现类
 *
 * @author 华大大模型
 */
@Service
@Validated
public class ModelAssessTaskStoplistServiceImpl implements ModelAssessTaskStoplistService {

    @Resource
    private ModelAssessTaskStoplistMapper modelAssessTaskStoplistMapper;

    @Override
    public Long createModelAssessTaskStoplist(ModelAssessTaskStoplistSaveReqVO createReqVO) {
        // 插入
        ModelAssessTaskStoplistDO modelAssessTaskStoplist = BeanUtils.toBean(createReqVO, ModelAssessTaskStoplistDO.class);
        modelAssessTaskStoplistMapper.insert(modelAssessTaskStoplist);
        // 返回
        return modelAssessTaskStoplist.getId();
    }

    @Override
    public void updateModelAssessTaskStoplist(ModelAssessTaskStoplistSaveReqVO updateReqVO) {
        // 校验存在
        validateModelAssessTaskStoplistExists(updateReqVO.getId());
        // 更新
        ModelAssessTaskStoplistDO updateObj = BeanUtils.toBean(updateReqVO, ModelAssessTaskStoplistDO.class);
        modelAssessTaskStoplistMapper.updateById(updateObj);
    }

    @Override
    public void deleteModelAssessTaskStoplist(Long id) {
        // 校验存在
        validateModelAssessTaskStoplistExists(id);
        // 删除
        modelAssessTaskStoplistMapper.deleteById(id);
    }

    private void validateModelAssessTaskStoplistExists(Long id) {
        if (modelAssessTaskStoplistMapper.selectById(id) == null) {
            throw exception(MODEL_ASSESS_TASK_STOPLIST_NOT_EXISTS);
        }
    }

    @Override
    public ModelAssessTaskStoplistDO getModelAssessTaskStoplist(Long id) {
        return modelAssessTaskStoplistMapper.selectById(id);
    }

    @Override
    public PageResult<ModelAssessTaskStoplistDO> getModelAssessTaskStoplistPage(ModelAssessTaskStoplistPageReqVO pageReqVO) {
        return modelAssessTaskStoplistMapper.selectPage(pageReqVO);
    }

}